package io.gitlab.jfronny.resclone.fetchers;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import io.gitlab.jfronny.resclone.data.RescloneException;

public class CurseforgeFetcher extends PackFetcher {
    @Override
    public String getSourceTypeName() {
        return "curseforge";
    }

    @Override
    public String getDownloadUrl(String baseUrl) throws RescloneException {
        try {
            JsonObject latest = (JsonObject)readJsonFromURL("https://addons-ecs.forgesvc.net/api/v2/addon/" + baseUrl + "/files", JsonArray.class).get(0);
            return latest.get("downloadUrl").getAsString();
        } catch (Throwable e) {
            throw new RescloneException("Could not get CF download for " + baseUrl, e);
        }
    }
}
